function vessel = ABC_trans(vessel)

% FOSSEN's script
Nfreqs  = length(vessel.freqs);
Nspeeds = length(vessel.velocities);

% zero speed terms
speed = 1;
A_0    = reshape(vessel.A(:,:,:,speed),6,6,Nfreqs);
B_0    = reshape(vessel.B(:,:,:,speed),6,6,Nfreqs);

% make zero speed matrices symmetric to account for numerical errors
for i=1:Nfreqs,
   A_0(1:6,1:6,i) = 0.5*(A_0(1:6,1:6,i) + A_0(1:6,1:6,i)');
   B_0(1:6,1:6,i) = 0.5*(B_0(1:6,1:6,i) + B_0(1:6,1:6,i)');   
end

% initial value
Bnew = vessel.B;        
Anew = vessel.A;  


% ---------------------------------------------------------------------
% compute: A11(0) = -2.7*(rho/L^2)*nabla^(5/3) c.f. Sding (1982)
% ---------------------------------------------------------------------
nabla = vessel.main.nabla;
Lpp   = vessel.main.Lpp;
rho   = vessel.main.rho;
A11_0 = 2.7*(rho/Lpp^2)*nabla^(5/3);  

A22_0 = vessel.A(2,2,1,1);

% ratio
alpha = A11_0/A22_0;

% ---------------------------------------------------------------------
% compute A11(w) and B11(w) by scaling the A22(w) and B22(w)data
% ---------------------------------------------------------------------
for speed=1:Nspeeds,
    for i=1:Nfreqs,
        Anew(1,1,i,speed) = alpha*Anew(2,2,i,speed);
        Bnew(1,1,i,speed) = alpha*Bnew(2,2,i,speed);
    end
end

vessel.A = Anew;
vessel.B = Bnew;
    