% Fitting of TF
function [Num,Den,Fresp_hat,stable] = fitting(Fresp,Omega,ord_num,ord_den,Weight)

% Weight can be []

% Method one
[Num,Den]=invfreqs(Fresp,Omega,ord_num,ord_den,Weight);   
Fresp_hat=freqs(Num,Den,Omega);   
stable=IsStable(Den);

% Method two
%iter=12;
% Weight=ones(size(Omega));
% for k=1:iter,
%     [Num,Den]=invfreqs(Fresp,Omega,ord_num,ord_den,Weight);
%     for m=1:length(Omega);
%     Weight(m)=1/abs(polyval(Den,complex(0,Omega(m))))^2;
%     end
% end
% stable=IsStable(Den);

%%%%%%%%%%%%%%%%%%
function out=IsStable(p)
%This function checks if a polynomial has roots in the 
%closed right half plane, and if so, the unstable roots are 
%reflected about the imaginary axis.
ut=1;
r=roots(p);
for k=1:length(r)
        if  real(r(k)) >= 0, 
            ut=0;
        end
end
out = ut;
