
function foil = foilcontrol(foil,U,wn0,xi0,plot_flag)

% Checking for plot variables
if ~exist('plot_flag','var')
    plot_flag = '0';
end

rho  = foil.main.rho;
cord = foil.main.cord;
span = foil.main.span;
I    = foil.main.I;
xCO  = foil.main.xCO;
xLO  = foil.main.xLO;

% Transfer function
% Variables
A1 = rho*pi*(cord/2)^2*span;
A2 = 0;%rho*pi*(cord/2)^4*span;
dL = 0.5*rho*cord*span*U^2*2*pi;
% System matrices
a =  I + A1*xCO^2 + A2;
b =  dL*xLO^2/U;
c = -dL*xLO;
%wn = sqrt(c/a);
%xi = b/(2*a*wn);

% Choosing wn0 and xi0 to adjust control parameters. ref pg 373 Fossen
%wn0 = 1; %15
%xi0 = 0.7; %0.7
w_lp = 20; % Low pass cut-off in deri. gain

Km = 0;
Tm = 1;
Kp = (a+Km)*wn0^2-c;
Kd = 2*xi0*wn0*(a+Km)-b;
Ki = 0;%wn0/10*Kp;

if strcmp(plot_flag,'1');   
    
    figure(60);

    t = 0:0.01:10;
    sys = tf(wn0^2,[1 2*xi0*wn0 wn0^2]); %eq 12.100
    step(sys,t);
end



foil.control.Km = Km;
foil.control.Tm = Tm;
foil.control.Kp = Kp;
foil.control.Kd = Kd;
foil.control.Ki = Ki;
foil.control.w_lp = w_lp;


