
function y = lpfilter(x,plot_flag,Fp,Fst,Ap,Ast)

% FCE 24.04.12

% Designing a zero-phase lowpass-filter:

if ~exist('Fp' ,'var');  Fp  = 0.07; end  % Frequency at start of stopband in normalized units (0-1)
if ~exist('Fst','var');  Fst = 0.10; end  % Frequency at the end of stopband in normalized units (0-1)
if ~exist('Ap' ,'var');  Ap  = 1.00; end  % Ripple in passband
if ~exist('Ast','var');  Ast = 60.0; end  % Attenuation in stopband (loss of intensity)

if ~exist('plot_flag','var')
    plot_flag = '0';
end

h  = fdesign.lowpass('Fp,Fst,Ap,Ast',Fp,Fst,Ap,Ast); % Designing low-pass filter
d  = design(h,'equiripple');                         % Lowpass FIR filter
y  = filtfilt(d.Numerator,1,x);                      % Zero-phase filtering (filtfilt)
y1 = filter(d.Numerator,1,x);                        % Custom filtering - one direction

% Fir filtering 
% n     = length(x);
% lp    = fir1(30,Fp);       % Designing a low pass filter - 30 = degreee
% y2    = filter(lp,1,x);    % Filtering noise with low pass
% y2(n) = y2(n-1);           % Adding length which was filtered away


%% Plotting 

if strcmp(plot_flag(1),'1')
    figure(20);
    hold on
    plot(x,'b');plot(y,'g');
    legend('Raw signal','Zero-phase filtered signal')
    hold off
end

if strcmp(plot_flag(1),'2')
    figure(20)
    hold on
    plot(x,'b');plot(y,'g');plot(y1,'r');
    legend('Raw signal','Zero-phase filtered signal','Filtered signal')
    hold off
end

