
clc
clear all
%close all

tic
 
% Foil dimensions in VERES-axes
foil.main.xf     = -46.525;
foil.main.yf     =   0.000;
foil.main.zf     = -12.676;
foil.main.g      =   9.807;
foil.main.rho    =  1025.0;
foil.main.span   =  28.072;
foil.main.cord   =   2.845;
%foil.main.xLO    =  -foil.main.cord/4;
%foil.main.xCO    =  -foil.main.cord/2;
foil.main.xLO    = -foil.main.cord/8;
foil.main.xCO    =  foil.main.cord/8;

foil.MClab.rho   = 999.7;
foil.MClab.scale = 16;

foil.mss = foil2mss(foil);

file_wFoil     = 'VERES\foil all head all vels\input';
file_wFoilABC  = 'VERES\foil all head all vels\inputABC';
file_woFoil    = 'VERES\No foil all heads all vels\input';
file_woFoilABC = 'VERES\No foil all heads all vels\inputABC';
folder_set     = 'VERES\foil setpoint heads vels';
file_resist    = 'VERES\Resistance and powering\seaway_shipx.seaway_res';

plot_flag = '1';
[Rt Vrt] = resistance(file_resist,plot_flag);
foil.vessel.resistance.Rt  = Rt;
foil.vessel.resistance.Vrt = Vrt;

[CL_mat,AoA,aoa,uppLim,lowLim,phi_opt] = CLgen;
foil.mss.main.CL_mat  = CL_mat;
foil.mss.main.AoA     = AoA;
foil.mss.main.aoa     = aoa;    % For phi_opt
foil.mss.main.uppLim  = uppLim;
foil.mss.main.lowLim  = lowLim;
foil.mss.main.phi_opt = phi_opt;

kn2ms    = 0.5144;
deg2rad  = pi/180;

% Set-points for simulation
U_set    = [8 10 12]*kn2ms;
Beta_set = 0*deg2rad;
T_set    = [11.5 10.5 9.5 8.5 7.5 6.5];

model = 'UnifiedModelManSeaFwdSpeed';
% Simulation
runModel;
%runoneModel;

ship = veres2struct(folder_set);
foil = foil2struct(foil,ship);

simfile = 'Monday1';
load(filename);
vesselSim(foil,ship)




%plot_flag = '1';
%foil.mss = fitTheodorsen(foil.mss,vessel,5.144,plot_flag);
% 
% plot_flag = '0';
% foil.mss = foilcontrol(foil.mss,U_set,plot_flag);



% filename = 'foil head 0 vel 0';
% folder   = strcat('VERES\',filename);
% 
% ship = veres2struct(folder);
% foil = foil2struct(foil,ship);
% 
% kn2ms   = 0.5144;
% deg2rad = pi/180;
% 
% % Experimental setup
% U    = [8 10 12]*kn2ms;
% Beta = [0 45 90 135 180]*deg2rad;
% 
% case_no   = 8;
% plot_flag = '111';
% postMC(foil,case_no,plot_flag);
% 
%plot_flag = '1';
%foil = fitTheodorsen(foil,ship,U(2),plot_flag);
% % 
% % plotRAO(foil,ship)
% 
% 
% save(filename);

toc



            