

% From experimental results
% NO FOIL
% U = 8 kn
w_set = [0.55,0.6,0.66,0.74,0.84,0.97];
Raw8  = [11,20.3,26.8,70.4,187.7,115.9];
Raw10 = [9.9,15.9,36.7,113.6,212.8,91.4];
Raw12 = [5,17.9,52.2,144.7,238.6,99.5];
exRaw = [Raw8' Raw10' Raw12'];

% FIXED FOIL
Raw8f  = [12 23 44 69 113 66];
Raw10f = [14 27 49 81 127 74];
Raw12f = [10 28 52 87 131 72]; 
exRawf = [Raw8f' Raw10f' Raw12f'];

diff8  = 1-Raw8f./Raw8;
diff10 = 1-Raw10f./Raw10;
diff12 = 1-Raw12f./Raw12;

figure(1)
hold on
plot(w_set,diff8*100,'-*b',w_set,diff10*100,'-*r',w_set,diff12*100,'-*g');
title('Reduction in added resistance');
xlabel('Wave frequency [1/s]');
ylabel('Reduction [%]');
legend('8kn','10kn','12kn','Location','SouthEast');
hold off

% nU    = length(U_set);
% 
% Bwl   = vessel.main.B;
% Lwl   = vessel.main.Lpp;
% rho   = vessel.main.rho;
% g     = vessel.main.g;
% vels  = vessel.velocities;
% 
% S1 = 1000; % kN->N
% S2 = 1/(Bwl^2/Lwl*rho*g);   % Dim. coeff

% for i = 1:nU
%    
%     U         = U_set(i);
%     [~,U_idx] = min(abs(vels-U));  % Finding index for setpoint velocity 
%     
%     % Beta Fossen (MSS): B_idx  = 19
%     B_idxMSS = 19;
%     % Beta Faltinsen (VERES): B_idx  = 1;
%     B_idx = 1;
%     
%     w     = vessel.driftfrc.w;
%     
%     load(file_wFoil);
%     load(file_wFoilABC); 
%     figure(100 + i);
%     hold on
%     
%     VERESraw  = abs(vessel.driftfrc.amp{1}(:,B_idxMSS,U_idx))*S2;
%     exRAWf    = exRawf(:,i)*S1*S2;
%     plot(w,VERESraw,'-b');
%     plot(w_set,exRAWf,'--*b');
%     
%     load(file_woFoil);
%     load(file_woFoilABC);
%     
%     VERESraw = abs(vessel.driftfrc.amp{1}(:,B_idxMSS,U_idx))*S2;
%     exRAW    = exRaw(:,i)*S1*S2;
%     plot(w,VERESraw,'-r');
%     plot(w_set,exRAW,'--or');
%     
%     title(strcat('Added resistance in Surge at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Added Ressitance [-], Raw/(B^2*rho*g/L)')
%         legend('Foil: Gerritsma&Beukelman - VERES',...
%             'Foil: Experimental (towing tank)',...
%             'No foil: Gerritsma&Beukelman - VERES',...
%             'No foil: Experimental (towing tank)');
%     
%     hold off
%     
%     
%     
% end




