% From VERES - Thomas Borgen
load('VesselSim15051117');
load('T_borgen');
%T_Borgen;
%Thrust;
%freqs;


load('Monday1');

% From experimental results
w_set = [0.55,0.6,0.66,0.74,0.84,0.97];
% FIXED FOIL
Tow8f  = [26.7 50.1 90.6 107.8 129.4 42.6];
Tow10f = [26.7 62.8 103.0 133.3 156.2 36.9];
Tow12f = [24.3 61.3 101.3 144.9 178.2 13.7]; 
exTowf = [Tow8f' Tow10f' Tow12f'];

nU    = length(U_set);
vels  = vessel.velocities;

S1 = 1000; % kN->N
ms2kn   = 1/0.5144;

for i = 1:nU
   
    U         = U_set(i);
    [~,U_idx] = min(abs(vels-U));  % Finding index for setpoint velocity 
    
    B_idx = 1;
    
    w     = w_set;
    w_idx = zeros(length(w),1);
    
    for j = 1:length(w)
        [~,w_idx(j)] = min(abs(freqs-w(j)));  % Finding index for setpoint freq.
    end
    T_Borgen_tmp = T_Borgen(w_idx,B_idx,i);
    Thrust_tmp   = Thrust(w_idx,B_idx,i);
    
    figure(110 + i);
    hold on
    
    outFF = output_wFoil(3,:,B_idx,i);
    outCF = output_wcFoil(3,:,B_idx,i);
    outSF = output_wsFoil(3,:,B_idx,i);
    expFF = exTowf(:,i)*S1;
    
    plot(w,outFF,'k',w,outCF,'o-b',w,outSF,'+-m',w,expFF,'*-k',w,T_Borgen_tmp,'r',w,Thrust_tmp,'g');

    title(strcat('Tow-force from foil at ',num2str(U*ms2kn),' knots'))
        xlabel('Wave frequency [1/s]')
        ylabel('Tow-force [N]')
        legend('Fixed foil',...
            'Controlled foil',...
            'Spring-loaded foil',...
            'Expermiental data',...
            'Fixed foil - VERES');
    
    hold off
    
     
end




