
clear all 
close all

folder = 'VERES\foil head 0 vel 8 10 12';
Foil = read_motionRAO(folder); 

freqs = Foil.freqs;

Rao8  = Foil.motionRAO.amp{3}(:,1,1);
Rao10 = Foil.motionRAO.amp{3}(:,1,2);
Rao12 = Foil.motionRAO.amp{3}(:,1,3);

Rao8p  = Foil.motionRAO.amp{5}(:,1,1);
Rao10p = Foil.motionRAO.amp{5}(:,1,2);
Rao12p = Foil.motionRAO.amp{5}(:,1,3);


% Experimental data Heave RAO
T_set    = [11.5 10.5 9.5 8.5 7.5 6.5];
w_set = 2*pi./T_set;

d2r = pi/180;

% HEAVE RAOs ---
% Without foil
rao8    = [0.8538,0.8101,0.6637,0.6411,0.6743,0.2519];
rao10   = [0.8991,0.8659,0.7844,0.7678,0.6351,0.1584];
rao12   = [0.9594,0.9428,0.9368,0.8930,0.6366,0.1569];
exRAOh  = [rao8' rao10' rao12'];

% With foil
rao8f   = [0.8666,0.8590,0.6506,0.5290,0.2597,0.1214];
rao10f  = [0.9129,0.8645,0.7264,0.5201,0.2285,0.1000];
rao12f  = [0.9575,0.8989,0.7431,0.5163,0.2494,0.1110];
exRAOhf = [rao8f' rao10f' rao12f'];

diff8  = 1-rao8f./rao8;
diff10 = 1-rao10f./rao10;
diff12 = 1-rao12f./rao12;

% PITCH RAOs ---
% Without foil
rao8p   = [1.6818,1.9901,2.4950,2.4573,2.6310,1.0176]*d2r;
rao10p  = [1.7213,2.0602,2.3469,2.6745,2.4833,0.7217]*d2r;
rao12p  = [1.8160,2.1917,2.5121,2.7853,2.3813,0.6542]*d2r;
exRAOp  = [rao8p' rao10p' rao12p'];
% With foil
rao8pf  = [1.4183,1.4890,1.6573,1.6553,1.3198,0.4500]*d2r;
rao10pf = [1.3870,1.5493,1.5494,1.5200,1.2323,0.3526]*d2r;
rao12pf = [1.3732,1.5112,1.5725,1.5253,1.1971,0.3421]*d2r;
exRAOpf = [rao8pf' rao10pf' rao12pf'];

diff8p  = 1-rao8pf./rao8p;
diff10p = 1-rao10pf./rao10p;
diff12p = 1-rao12pf./rao12p;

% figure(1)
% hold on
% plot(w_set,diff8*100,'-*b',w_set,diff10*100,'-*r',w_set,diff12*100,'-*g');
% title('Reduction in heave response');
% xlabel('Wave frequency [1/s]');
% ylabel('Reduction [%]');
% legend('8kn','10kn','12kn','Location','SouthEast');
% hold off
% figure(2)
% hold on
% plot(w_set,diff8p*100,'-*b',w_set,diff10p*100,'-*r',w_set,diff12p*100,'-*g');
% title('Reduction in pitch response');
% xlabel('Wave frequency [1/s]');
% ylabel('Reduction [%]');
% legend('8kn','10kn','12kn','Location','SouthEast');
% hold off

% figure(1)
% hold on
% plot(freqs,Rao8,'b',freqs,Nofoil.motionRAO.amp{3}(:),'g',freqs,heave_RAO,'m');
% plot(w_set,rao10f,'*c',w_set,rao10,'*g');
% 
% title(strcat('Heave motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Heave RAO [-]')
%         legend('Foil: Time-dom. frequency response',...
%             'Foil: Freq-dom VERES calculation',...
%             'No foil: Freq-dom VERES calculation',...
%             'No foil: Time-dom. frequency response',...
%             'Foil: Time-dom experimental results',...
%             'No foil: Time-dom experimental results');
% 
% hold off
% 
% figure(2)
% hold on
% plot(freqs,pitch_RAOf,'r',freqs,vessel.motionRAO.amp{5}(:),'b',...
%     freqs,Nofoil.motionRAO.amp{5}(:),'g',freqs,pitch_RAO,'m');
% plot(w_set,rao10pf,'*c',w_set,rao10p,'*g');
% 
% title(strcat('Pitch motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Pitch RAO [deg]')
%         legend('Foil: Time-dom. frequency response',...
%             'Foil: Freq-dom VERES calculation',...
%             'No foil: Freq-dom VERES calculation',...
%             'No foil: Time-dom. frequency response',...
%             'Foil: Time-dom experimental results',...
%             'No foil: Time-dom experimental results');
% 
% hold off


%8 KNOTS
% load('sat');
% U = 8;
% folder = 'VERES\No foil head 0 vel 8';
% Nofoil = read_motionRAO(folder); 
% figure(1)
% hold on
% plot(freqs,Nofoil.motionRAO.amp{3}(:),'r',...
%     freqs,Rao8,'b');%,freqs,heave_RAO,'-b*','MarkerSize',4);
% plot(w_set,rao8,'*r');
% plot(w_set,rao8f,'*b');
% plot(w_set,output_wFoil(4,:,1,1));
% 
% title(strcat('Heave motion of vessel at ',num2str(U),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Heave RAO [-]')
%         legend('No foil: VERES',...
%             'Foil: VERES',...
%             'No foil: Experimental',...
%             'Foil: Experimental');
% 
% hold off
% 
% figure(2)
% load('sat');
% hold on
% plot(freqs,Nofoil.motionRAO.amp{5}(:),'r',...
%     freqs,Rao8p,'b');%,freqs,pitch_RAO,'-b*','MarkerSize',4);
% plot(w_set,rao8p,'*r');
% plot(w_set,rao8pf,'*b');
% 
% title(strcat('Pitch motion of vessel at ',num2str(U),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Pitch RAO [deg]')
%         legend('No foil: VERES',...
%             'Foil: VERES',...
%             'No foil: Experimental',...
%             'Foil: Experimental');
% 
% hold off
% 
% %10 KNOTS
U = 10;
load('sat');
folder = 'VERES\No foil head 0 vel 10';
Nofoil = read_motionRAO(folder); 
figure(3)
hold on
plot(freqs,Nofoil.motionRAO.amp{3}(:),'r',...
    freqs,Rao10,'b');%,freqs,heave_RAO,'-b*','MarkerSize',4);
plot(w_set,rao10,'*r');
plot(w_set,rao10f,'*b');
plot(w_set,output_wFoil(4,:,1,2));

title(strcat('Heave motion of vessel at ',num2str(U),' knots'))
        xlabel('Wave frequency [1/s]')
        ylabel('Heave RAO [-]')
        legend('No foil: VERES',...
            'Foil: VERES',...
            'No foil: Experimental',...
            'Foil: Experimental');

hold off
% 
% figure(4)
% hold on
% plot(freqs,Nofoil.motionRAO.amp{5}(:),'r',...
%     freqs,Rao10p,'b');%,freqs,pitch_RAO,'-b*','MarkerSize',4);
% plot(w_set,rao10p,'*r');
% plot(w_set,rao10pf,'*b');
% 
% title(strcat('Pitch motion of vessel at ',num2str(U),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Pitch RAO [deg]')
%         legend('No foil: VERES',...
%             'Foil: VERES',...
%             'No foil: Experimental',...
%             'Foil: Experimental');
% 
% hold off
% 
% %12 KNOTS
U  = 12;
load('sat');
folder = 'VERES\No foil head 0 vel 12';
Nofoil = read_motionRAO(folder); 
figure(5)
hold on
plot(freqs,Nofoil.motionRAO.amp{3}(:),'r',...
    freqs,Rao12,'b');%,freqs,heave_RAO,'-b*','MarkerSize',4);
plot(w_set,rao12,'*r');
plot(w_set,rao12f,'*b');
plot(w_set,output_wFoil(4,:,1,3));

title(strcat('Heave motion of vessel at ',num2str(U),' knots'))
        xlabel('Wave frequency [1/s]')
        ylabel('Heave RAO [-]')
        legend('No foil: VERES',...
            'Foil: VERES',...
            'No foil: Experimental',...
            'Foil: Experimental');

hold off

% figure(6)
% hold on
% plot(freqs,Nofoil.motionRAO.amp{5}(:),'r',...
%     freqs,Rao12p,'b');%,freqs,pitch_RAO,'-b*','MarkerSize',4);
% plot(w_set,rao12p,'*r');
% plot(w_set,rao12pf,'*b');
% 
% title(strcat('Pitch motion of vessel at ',num2str(U),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Pitch RAO [deg]')
%         legend('No foil: VERES',...
%             'Foil: VERES',...
%             'No foil: Experimental',...
%             'Foil: Experimental');
% 
% hold off