function [Rt V] = resistance(file,plot_flag)

if ~exist('plot_flag','var')
    plot_flag = '0';
end

% Experimental results
Rt_Ex = [8.5,22.3,44.2,83.1,132.7]*1000;
V_Ex  = [4 6 8 10 12]*0.5144;

% VERES numerical results
fid = fopen(file);
for i = 1:2;
    fgetl(fid);
end

n      = fscanf(fid,'%f',1);
[V_VERES Rt_VERES] = deal(zeros(n,1));

for i = 1:n;
    read = fscanf(fid,'%f',2);
    read = num2cell(read);
    [V_VERES(i) Rt_VERES(i)] = deal(read{:});
end

V_VERES  = V_VERES*0.5144; % To m/s
Rt_VERES = Rt_VERES*1000;  % To kN

Vmax  = max(V_VERES);
V     = 0:0.1:Vmax;
Rt    = polyval(polyfit(V_Ex,Rt_Ex,3),V);

if strcmp(plot_flag,'1')

    figure(50)
    hold on
    plot(V_Ex,Rt_Ex,'*r')
    plot(V,Rt,'b')
    plot(V_VERES,Rt_VERES,'--m')
    title('Calm water resistance for vessel','FontWeight','bold');
    legend('Experimental (Towing-tank)','Experimental trendline','Holtrop-VERES');
    xlabel('Velocity [m/s]')
    ylabel('Resistance, Rt [kN]')
    hold off

end

end



