
nBeta = length(Beta_set);
nU    = length(U_set);
nT    = length(T_set);
n     = nT*nU*nBeta*4;
l     = 0;  % Counter

output_wFoil  = zeros(5,nT,nBeta,nU);
output_wcFoil = zeros(5,nT,nBeta,nU);
output_wsFoil = zeros(5,nT,nBeta,nU);
output_woFoil = zeros(5,nT,nBeta,nU);


f = 1;
%for f = 1:4;

    if f == 1;              % Fixed foil
        onofffoil = 1;
            confoil = 0;
            fixfoil = 1;
            negpos = 1;
    elseif f == 2;          % Controlled foil
        onofffoil = 1;
            confoil = 1;
            fixfoil = 0;
            negpos = -1;
    elseif f == 3;          % Spring-loaded foil
        onofffoil = 1;
            confoil = 0;
            fixfoil = 1; 
            negpos = 1;
    else                    % No foil
        onofffoil = 0;
        negpos = 1;
    end


    for i = 1:nU;
        U = U_set(i);    
         
        for j = 1:nBeta;
            Beta = Beta_set(j);

            
            for h = 1:nT;
                T = T_set(h);

                foil.mss = fitTheodorsen(foil.mss,vessel,U);
                
                if f == 3;
                    foil.mss.main.xLO    =  foil.main.cord/4;
                    foil.mss.main.xCO    =  foil.main.cord/2;
                    wn0 = 3;
                    xi0 = 0.7;
                    foil.mss = foilcontrol(foil.mss,U,wn0,xi0);
                    foil.control.Kd = 0;
                    foil.control.Ki = 0;
                    
                elseif f == 1;
                    foil.mss.main.xLO    =  foil.main.cord/4;
                    foil.mss.main.xCO    =  foil.main.cord/2;
                    wn0 = 15;
                    xi0 = 0.7;
                    foil.mss = foilcontrol(foil.mss,U,wn0,xi0);
                    
                else 
                    foil.mss.main.xLO    = -foil.main.cord/8;
                    foil.mss.main.xCO    =  foil.main.cord/8;
                    wn0 = 15;
                    xi0 = 0.7;
                    foil.mss = foilcontrol(foil.mss,U,wn0,xi0);
                end
 
                foil.mss.control.delta_cons = 0;
                
                simOut = sim(model);

                time       = FoilThrust.time;
                foilthrust = FoilThrust.signals.values;
                propthrust = PropThrust.signals.values;
                addres     = AddRes.signals.values;
                pitch      = Pitch.signals.values;
                heave      = Heave.signals.values;

                %n  = length(time);
                dt = time(2)-time(1);
                %f  = 1/dt; %Hz

                % Time intervall for signal processing
                timeStart = 250;
                timeStop  = 500;

                nStart = timeStart/dt + 1;
                nStop  = timeStop/dt + 1;

                MeanFT = mean(foilthrust(nStart:nStop));
                StdFT  = std(foilthrust(nStart:nStop));

                MeanPT = mean(propthrust(nStart:nStop));
                StdPT  = std(propthrust(nStart:nStop));

                MeanAR = mean(addres(nStart:nStop));
                StdAR  = std(addres(nStart:nStop));

                MeanPI = mean(pitch(nStart:nStop));
                StdPI  = std(pitch(nStart:nStop));
                AmpPI  = sqrt(2)*StdPI;

                MeanHE = mean(heave(nStart:nStop));
                StdHE  = std(heave(nStart:nStop));
                AmpHE  = sqrt(2)*StdHE;
                
                if f == 1;
                    output_wFoil(:,h,j,i)  = [MeanPT MeanAR MeanFT AmpHE AmpPI];
                elseif f == 2;
                    output_wcFoil(:,h,j,i) = [MeanPT MeanAR MeanFT AmpHE AmpPI];
                elseif f == 3;
                    output_wsFoil(:,h,j,i) = [MeanPT MeanAR MeanFT AmpHE AmpPI];
                else    
                    output_woFoil(:,h,j,i) = [MeanPT MeanAR MeanFT AmpHE AmpPI];
                end
                
                % Calculating time spent and left
                l = l+1;
                total = l/n*100
                               
            end
        end
    end
%end

   

