
f = 1;

U = U_set(2);    

Beta = Beta_set(1);

T = T_set(3);


load(file_woFoil);
load(file_woFoilABC);

if f == 1;              % Fixed foil
    onofffoil = 1;
        confoil = 0;
        fixfoil = 1;
elseif f == 2;          % Controlled foil
    onofffoil = 1;
        confoil = 1;
        fixfoil = 0;
elseif f == 3;          % Spring-loaded foil
    onofffoil = 1;
        confoil = 0;
        fixfoil = 1;       
else                    % No foil
    onofffoil = 0;
end

plot_flag = '0';
foil.mss = fitTheodorsen(foil.mss,vessel,U,plot_flag);

if f == 3;
    wn0 = 5;
    xi0 = 0.7;
    foil.mss = foilcontrol(foil.mss,U,wn0,xi0);
    foil.control.Kd = 0;
    foil.control.Ki = 0;
else 
    wn0 = 15;
    xi0 = 0.7;
    foil.mss = foilcontrol(foil.mss,U,wn0,xi0);
end

foil.mss.control.delta_cons = 0;

simOut = sim(model);

time       = FoilThrust.time;
foilthrust = FoilThrust.signals.values;
propthrust = PropThrust.signals.values;
addres     = AddRes.signals.values;
pitch      = Pitch.signals.values;
heave      = Heave.signals.values;

%n  = length(time);
dt = time(2)-time(1);
%f  = 1/dt; %Hz

% Time intervall for signal processing
timeStart = 250;
timeStop  = 500;

nStart = timeStart/dt + 1;
nStop  = timeStop/dt + 1;

MeanFT = mean(foilthrust(nStart:nStop));
StdFT  = std(foilthrust(nStart:nStop));

MeanPT = mean(propthrust(nStart:nStop));
StdPT  = std(propthrust(nStart:nStop));

MeanAR = mean(addres(nStart:nStop));
StdAR  = std(addres(nStart:nStop));

MeanPI = mean(pitch(nStart:nStop));
StdPI  = std(pitch(nStart:nStop));
AmpPI  = sqrt(2)*StdPI;

MeanHE = mean(heave(nStart:nStop));
StdHE  = std(heave(nStart:nStop));
AmpHE  = sqrt(2)*StdHE;


   

