function [T k_f S] = theodorsen(c,U,w)

% Fridtjof Camillo Eitzen
% Created: 31.10.2011
% -------------
% Requirements: Finds the Sears and Theodorsen function-value
% Design:
% Interface:
% Last edited: 31.10.2011
% -------------

k_f = w*c/(2*U);      % Reduced frequency

H12 = besselj(1,k_f)-1i*bessely(1,k_f);
H02 = besselj(0,k_f)-1i*bessely(0,k_f);
T = H12/(H12 + 1i*H02);                 % Theodorsen function: ref Seealoads
S = 2i/((pi*k_f)*(H12 + 1i*H02));       % Sears function: ref Newman (p230) 

end