clear all

% folder    = 'VERES\No foil head 0 vel 0';
% vessel    = veres2struct(folder);
% vesselABC = struct2ss(vessel);
% % save('TimeDomain');
%return;
load('TimeDomain');

% folder = 'VERES\No foil head 0 vel 8';
% Nofoil = read_motionRAO(folder); 
% %Nofoil = read_ABC(folder); 

folder = 'VERES\No foil head 0 vel 12';
Nofoil = read_motionRAO(folder); 
% %Nofoil = read_ABC(folder);


folder = 'VERES\No foil head 0 vel 12';
vessel  = veres2struct(folder);

folder = 'VERES\foil head 0 vel 8 10 12';
Foil = veres2struct(folder);
foil   = foilDim;
foil   = foil2struct(foil,vessel);

[CL_mat,AoA,~,~,~,phi] = CLgen;     % Runs script - CL matrix
CL = 4.87;

% Resistance
% Experimental results
Rt_Ex = [8.5,22.3,44.2,83.1,132.7]*1000;
V_Ex  = [4 6 8 10 12]*0.5144;
Vmax  = 15*0.5144;
V     = 0:0.1:Vmax;
Rt    = polyval(polyfit(V_Ex,Rt_Ex,3),V);

    
% Preparing SIMULINK model
modelf  = 'vesselSIMU2';
%modelf = 'vesselFoilFluidMem';

idx_M = [3,5];
M     = vesselABC.M(idx_M,idx_M);
Ainf  = vesselABC.Ainf(idx_M,idx_M);
Minv  = inv(M+Ainf);

U    = vessel.velocities;

L_tmp      = zeros(6);
L_tmp(2,6) =  1;
L_tmp(3,5) = -1;

%CA = -U*[0 0 0; 0 0 Ainf(2,2); 0 -Ainf(2,2) 0];
CA = -U*[0 Ainf(1,1);-Ainf(1,1) 0];
%CA = -U*[0 0 0; 0 0 Ainf(1,1); 0 Ainf(1,1)-Ainf(2,2) Ainf(3,2)];
%CM = U*[0 0 0; 0 0 -M(2,2); 0 M(2,2) 0];
%CM = -U*[0 0 0; 0 0 -M(1,1); 0 0 0];
CM=zeros(2);

e_tmp      = [1 0 0 0 0 0]';

L = L_tmp(idx_M,idx_M);
C = vesselABC.C(idx_M,idx_M);
e = e_tmp(idx_M);

psi_a  = 1;
g      = vessel.main.g;
rho    = vessel.main.rho;
freqs  = vessel.freqs;
nfreqs = length(freqs);


wn0  = 1.31;
xi0  = 1;
foil = foilControl(foil,U,wn0,xi0);
foil = fitTheodorsen(foil,vessel,U,'0');

[heave_RAO,pitch_RAO]   = deal(zeros(nfreqs,1));
[heave_RAOf,pitch_RAOf] = deal(zeros(nfreqs,1));
[thrustout] = deal(zeros(nfreqs,1));

x_transom    = vessel.main.Lpp/2;
x_t          = x_transom;
b_transom    = vessel.main.W/2.75;
a33_transom  = rho*pi/2*(b_transom/2)^2;        % High-frequency
% b33_dim_lim  = 0.2;  %8/pi Limit zero freq. Faltinsen pg 49. B/(rho*freq*a33_tran)
% b33_transom  = b33_dim_lim*a33_transom;

for i = 1:nfreqs;
%i = 5;
    
    w    = freqs(i); 
    w_e  = w + w^2/g*U;
    F    = vessel.forceRAO.complex(idx_M,i);
    
    wave = foil.Wave(i);
    
%     sim(model);
%     heave_RAO(i)  = sqrt(2)*std(heavedisp.signals.values(floor(end/2):end))/psi_a;
%     pitch_RAO(i)  = sqrt(2)*std(pitchdisp.signals.values(floor(end/2)/2:end));
%     
    sim(modelf);
    heave_RAOf(i)  = sqrt(2)*std(heavedisp.signals.values(floor(end/2)/2:end))/psi_a;
    pitch_RAOf(i)  = sqrt(2)*std(pitchdisp.signals.values(floor(end/2)/2:end));
    thrustout(i)  = mean(thrustforce.signals.values(floor(end/2)/2:end));
           
end


T_set = [11.5 10.5 9.5 8.5 7.5 6.5];
w_set = 2*pi./T_set;
rad2deg = 180/pi;
ms2kn   = 1/0.5144;


% Ex heave
rao8    = [0.8538,0.8101,0.6637,0.6411,0.6743,0.2519];
rao10   = [0.8991,0.8659,0.7844,0.7678,0.6351,0.1584];
rao12   = [0.9594,0.9428,0.9368,0.8930,0.6366,0.1569];

% With foil
rao8f   = [0.8666,0.8590,0.6506,0.5290,0.2597,0.1214];
rao10f  = [0.9129,0.8645,0.7264,0.5201,0.2285,0.1000];
rao12f  = [0.9575,0.8989,0.7431,0.5163,0.2494,0.1110];

% Ex pitch
rao8p   = [1.6818,1.9901,2.4950,2.4573,2.6310,1.0176]/rad2deg;
rao10p  = [1.7213,2.0602,2.3469,2.6745,2.4833,0.7217]/rad2deg;
rao12p  = [1.8160,2.1917,2.5121,2.7853,2.3813,0.6542]/rad2deg;

% With foil
rao8pf  = [1.4183,1.4890,1.6573,1.6553,1.3198,0.4500]/rad2deg;
rao10pf = [1.3870,1.5493,1.5494,1.5200,1.2323,0.3526]/rad2deg;
rao12pf = [1.3732,1.5112,1.5725,1.5253,1.1971,0.3421]/rad2deg;




% figure(1)
% hold on
% plot(freqs,heave_RAOf,'r',freqs,vessel.motionRAO.amp{3}(:),'b',...
%     freqs,Nofoil.motionRAO.amp{3}(:),'g',freqs,heave_RAO,'m');
% plot(w_set,rao10f,'*c',w_set,rao10,'*g');
% 
% title(strcat('Heave motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Heave RAO [-]')
%         legend('Foil: Time-dom. frequency response',...
%             'Foil: Freq-dom VERES calculation',...
%             'No foil: Freq-dom VERES calculation',...
%             'No foil: Time-dom. frequency response',...
%             'Foil: Time-dom experimental results',...
%             'No foil: Time-dom experimental results');
% 
% hold off
% 
% figure(2)
% hold on
% plot(freqs,pitch_RAOf,'r',freqs,vessel.motionRAO.amp{5}(:),'b',...
%     freqs,Nofoil.motionRAO.amp{5}(:),'g',freqs,pitch_RAO,'m');
% plot(w_set,rao10pf,'*c',w_set,rao10p,'*g');
% 
% title(strcat('Pitch motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Pitch RAO [deg]')
%         legend('Foil: Time-dom. frequency response',...
%             'Foil: Freq-dom VERES calculation',...
%             'No foil: Freq-dom VERES calculation',...
%             'No foil: Time-dom. frequency response',...
%             'Foil: Time-dom experimental results',...
%             'No foil: Time-dom experimental results');
% 
% hold off
% 
% % 8 KNOTS
% figure(1)
% hold on
% plot(freqs,Nofoil.motionRAO.amp{3}(:),'r','LineWidth',1);
% plot(freqs,heave_RAO,'-b*','MarkerSize',4,'LineWidth',1)
% plot(w_set,rao8,'ok','MarkerSize',6,'LineWidth',1);
% 
% title(strcat('Heave motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Heave RAO [-]')
%         legend('No foil: Freq-dom VERES calculation',...
%             'No foil: Time-dom. frequency response',...
%             'No foil: Time-dom experimental results');
% 
% hold off
% 
% figure(2)
% hold on
% plot(freqs,Nofoil.motionRAO.amp{5}(:),'r');
% plot(freqs,pitch_RAO,'-b*','MarkerSize',4);
% plot(w_set,rao8p,'ok');
% 
% title(strcat('Pitch motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Pitch RAO [deg]')
%         legend('No foil: Freq-dom VERES calculation',...
%             'No foil: Time-dom. frequency response',...
%             'No foil: Time-dom experimental results');
% 
% hold off

% % 10 KNOTS
% figure(1)
% hold on
% plot(freqs,Nofoil.motionRAO.amp{3}(:),'r',freqs,heave_RAO,'-b*','MarkerSize',4);
% plot(w_set,rao10,'ok');
% 
% title(strcat('Heave motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Heave RAO [-]')
%         legend('No foil: Freq-dom VERES calculation',...
%             'No foil: Time-dom. frequency response',...
%             'No foil: Time-dom experimental results');
% 
% hold off
% 
% figure(2)
% hold on
% plot(freqs,Nofoil.motionRAO.amp{5}(:),'r',freqs,pitch_RAO,'-b*','MarkerSize',4);
% plot(w_set,rao10p,'ok');
% 
% title(strcat('Pitch motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Pitch RAO [deg]')
%         legend('No foil: Freq-dom VERES calculation',...
%             'No foil: Time-dom. frequency response',...
%             'No foil: Time-dom experimental results');
% 
% hold off


%12 KNOTS
% figure(1)
% hold on
% plot(freqs,Nofoil.motionRAO.amp{3}(:),'r',freqs,heave_RAO,'-b*','MarkerSize',4);
% plot(w_set,rao12,'ok');
% 
% title(strcat('Heave motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Heave RAO [-]')
%         legend('No foil: Freq-dom VERES calculation',...
%             'No foil: Time-dom. frequency response',...
%             'No foil: Time-dom experimental results');
% 
% hold off
% 
% figure(2)
% hold on
% plot(freqs,Nofoil.motionRAO.amp{5}(:),'r',freqs,pitch_RAO,'-b*','MarkerSize',4);
% plot(w_set,rao12p,'ok');
% 
% title(strcat('Pitch motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Pitch RAO [deg]')
%         legend('No foil: Freq-dom VERES calculation',...
%             'No foil: Time-dom. frequency response',...
%             'No foil: Time-dom experimental results');
% 
% hold off

% figure(3)
% 
% eta3TS = heavedisp.signals.values;
% dt     = 0.02;
% nt     = length(eta3TS)-1;
% time   = (0:nt)*dt;
% psi    = psi_a.*exp(1i.*w_e.*time);
% RAO    = vessel.motionRAO.amp{3}(i);
% eta3   = psi*RAO;
% hold on
% plot(time,eta3TS,time,eta3,'r');


%8 KNOTS
% figure(1)
% hold on
% plot(freqs,Foil.motionRAO.amp{3}(:,1,1),'g','LineWidth',1);
% plot(freqs,heave_RAOf,'-b*','MarkerSize',4,'LineWidth',1)
% plot(w_set,rao8f,'*r','MarkerSize',6,'LineWidth',1);
% 
% title(strcat('Heave motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Heave RAO [-]')
%         legend('Foil: VERES',...
%             'Foil: Time-domain',...
%             'Foil: Experimental');
% 
% hold off
% 
% figure(2)
% hold on
% plot(freqs,Foil.motionRAO.amp{5}(:,1,1),'g');
% plot(freqs,pitch_RAOf,'-b*','MarkerSize',4);
% plot(w_set,rao8pf,'*r');
% 
% title(strcat('Pitch motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Pitch RAO [deg]')
%         legend('Foil: VERES',...
%             'Foil: Time-domain',...
%             'Foil: Experimental','Location','NorthEast');
% 
% hold off

% % % 10 KNOTS
% figure(1)
% hold on
% plot(freqs,Foil.motionRAO.amp{3}(:,1,2),'g',freqs,heave_RAOf,'-b*','MarkerSize',4);
% plot(w_set,rao10f,'*r');
% 
% title(strcat('Heave motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Heave RAO [-]')
%         legend('Foil: VERES',...
%             'Foil: Time-domain',...
%             'Foil: Experimental');
% 
% hold off
% 
% figure(2)
% hold on
% plot(freqs,Foil.motionRAO.amp{5}(:,1,2),'g',freqs,pitch_RAOf,'-b*','MarkerSize',4);
% plot(w_set,rao10pf,'*r');
% 
% title(strcat('Pitch motion of vessel at ',num2str(U*ms2kn),' knots'))
%         xlabel('Wave frequency [1/s]')
%         ylabel('Pitch RAO [deg]')
%         legend('Foil: VERES',...
%             'Foil: Time-domain',...
%             'Foil: Experimental');
% 
% hold off

% 
% %12 KNOTS
figure(1)
hold on
plot(freqs,Foil.motionRAO.amp{3}(:,1,3),'g',freqs,heave_RAOf,'-b*','MarkerSize',4);
plot(w_set,rao12f,'*r');

title(strcat('Heave motion of vessel at ',num2str(U*ms2kn),' knots'))
        xlabel('Wave frequency [1/s]')
        ylabel('Heave RAO [-]')
        legend('Foil: VERES',...
            'Foil: Time-domain',...
            'Foil: Experimental');

hold off

figure(2)
hold on
plot(freqs,Foil.motionRAO.amp{5}(:,1,3),'g',freqs,pitch_RAOf,'-b*','MarkerSize',4);
plot(w_set,rao12pf,'*r');

title(strcat('Pitch motion of vessel at ',num2str(U*ms2kn),' knots'))
        xlabel('Wave frequency [1/s]')
        ylabel('Pitch RAO [deg]')
        legend('Foil: VERES',...
            'Foil: Time-domain',...
           'Foil: Experimental');

hold off

% figure(3)
% 
% eta3TS = heavedisp.signals.values;
% dt     = 0.02;
% nt     = length(eta3TS)-1;
% time   = (0:nt)*dt;
% psi    = psi_a.*exp(1i.*w_e.*time);
% RAO    = vessel.motionRAO.amp{3}(i);
% eta3   = psi*RAO;
% hold on
% plot(time,eta3TS,time,eta3,'r');


























